#include "I2c.h"
#define I2c_time_out  10000

void I2c_Init (uint32_t OutputClockFrequencyHz)
{
  CLK_PeripheralClockConfig(CLK_PERIPHERAL_I2C, ENABLE);
  I2C_Init(OutputClockFrequencyHz, 0xA0, I2C_DUTYCYCLE_2, I2C_ACK_NONE, I2C_ADDMODE_7BIT, 16);
  I2C_Cmd(ENABLE);  
}

u8 I2c_Start (void)
{
  if ((I2C->SR3&0x02)==1) return I2c_ERROR_BUS_BUSY;
  I2C_busy();
  I2C_start();
  while(I2C_SBask==0);
  return I2c_SUCCESS;
}

u8 I2c_SendAddress (u8 data)
{
  u16 cnt=I2c_time_out;
  I2C_writebyte(data); 
  while(I2C_addrask==0)
  {
    cnt--;
    if (cnt==0) return I2c_ERROR_NO_ACK;
  }
  I2C_busy();
  return I2c_SUCCESS;
}

void I2c_WriteByte (u8 data)
{
  I2C_writebyte(data);
  I2C_busy();
  while(I2C_TxEask==0);
}

u8 I2C_RcvDat(void)
{
  u8 i;
  while(I2C_RxNeask==0);
abc:
  if(I2C_BTF==0x04) i=I2C->DR;
  else goto abc;
  if(I2C_BTF==0){}
  else goto abc;
  return i;
}

u8 I2c_Read_Page_1 (u8 I2c_Address, u8 Mem_Address, u8 * pBuffer, u8 pBufferSize)
{
  u8 err=0;
  err=I2c_Start();
  if (err) return err;
  err=I2c_SendAddress(I2c_Address);
  if (err) return err;
  I2c_WriteByte(Mem_Address);
  I2c_Start();
  I2c_SendAddress(I2c_Address|1);
  I2C_Ack();
  while (pBufferSize) 
  {
    * pBuffer++ = I2C_RcvDat();
    pBufferSize--;
    if (!pBufferSize) I2C_NAck();
  }
  I2C_stop();
  
  return I2c_SUCCESS;  
}

unsigned char I2c_Write_Register (unsigned char I2c_Address, unsigned char Reg, unsigned char data)
{
	if (I2c_Start()) return I2c_ERROR_BUS_BUSY;
	if (I2c_SendAddress(I2c_Address)) return I2c_ERROR_NO_ACK;
	I2c_WriteByte(Reg);
	I2c_WriteByte(data);
	I2C_stop();  
	return 0;
}
