#include "stm8s.h"

#define I2c_SUCCESS         0x00
#define I2c_ERROR_BUS_BUSY  0x01  
#define I2c_ERROR_NO_ACK    0x02
#define I2c_TimeOutError    0x03

#define I2C_busy()                 while((I2C->SR3&0x02)==1);
#define I2C_start()                 I2C->CR2|=0x01;
#define I2C_stop()                 I2C->CR2|=0x02; while (I2C->SR1&(1<<4)==0); 

#define I2C_Ack()                  I2C->CR2|=0x04;
#define I2C_NAck()                I2C->CR2&=(~0x04); 

#define I2C_addrask              (I2C->SR1&0x02)
#define I2C_SBask                 (I2C->SR1&0x01)
#define I2C_TxEask                (I2C->SR1&0x80)
#define I2C_RxNeask              (I2C->SR1&0x40)
#define I2C_BTF                     (I2C->SR1&0x04) 

#define I2C_writebyte(x)         I2C->DR=x;

void I2c_Init (uint32_t OutputClockFrequencyHz);
u8 I2c_Start (void);
u8 I2c_SendAddress (u8 data);
void I2c_WriteByte (u8 data);
void I2c_Stop (void);
u8 I2C_RcvDat(void);
u8 I2c_Read_Page_1 (u8 I2c_Address, u8 Mem_Address, u8 * pBuffer, u8 pBufferSize);
unsigned char I2c_Write_Register (unsigned char I2c_Address, unsigned char Reg, unsigned char data);